package provide dnetlib 2.0

namespace eval dnet {
    namespace export open importPacket send

    variable buffers
    variable devices

  proc importPacket {bufID} {
    variable buffers

    # How long is the payload

    set len [$bufID length]

    set buffers(Len.$bufID) $len

    set buffers($bufID) [dnet::new_uint_8Array $len]
puts "LEN: $len"
     set i -1;
     foreach b [$bufID getField packet] {
        dnet::set_uint_8Array $buffers($bufID) [incr i] $b
    }
    return $bufID
  }

  proc open {device} {
      variable devices
      set devices($device) [dnet::eth_open $device]
      return $device
  }

  proc send {device bufID} {
      variable devices
      variable buffers
      
      if {![info exists buffers($bufID)]} {
          importPacket $bufID
      }
      dnet::eth_send $devices($device) $buffers($bufID) $buffers(Len.$bufID)
  }
    
}

