set rev(ether.tcl) {$Header: /home/cvs/PacketMaker/ether.tcl,v 1.2 2002/12/31 02:40:01 clif Exp $}
#####################################################################
;# NAME:   ether.tcl
;# AUTHOR: Clif Flynt
;# DATE:   11/2002
;# DESC:   Procedures for ethernet packets.
;#         
;#         
;#
;# PARAMETERS:  
;#
;#
#####################################################################
# This code is written and copyrighted by Clif Flynt, 2002
#
# It is licenced for public use with these terms:
#
#  This licence agreement must remain intact with the code.
# 
#  You may use this code freely for non-commercial purposes.
#
#  You may examine and modify the code to your heart's content.
#
#  You may not claim to have authored the code (aside from modifications
#  you may have made.)
#
#  You may not distribute the code without this license agreement
#
#  You may not sell this code or distribute it with a commercial product
#      without arrangements with Noumena Corporation.
#
#  Maintenance, extension, modification, etc can be performed by:
#
#   Noumena Corporation
#   9300 Fleming Rd.
#   Dexter, MI  48130
#
#   Contact: clif@noucorp.com
#
#####################################################################


package provide ether 1.0

namespace eval ether {
    variable fields
    namespace export genPacket replaceField
    
    
    proc genPacket {} {
      upvar fieldArray dataArray

      variable fields
      variable lookup

      set dataArray(packet) \
          [packet::MakePayload $fields lookup dataArray]
    }

}



