set rev(tcp_def.tcl) {$Header: /home/cvs/PacketMaker/tcp_def.tcl,v 1.1.1.1 2002/12/02 01:37:04 clif Exp $}
#####################################################################
;# NAME:   tcp_def.tcl
;# AUTHOR: Clif Flynt
;# DATE:   11/2002
;# DESC:   Definitions for TCP packets
;#         
;#         
;#
;# PARAMETERS:  
;#
;#
#####################################################################
# This code is written and copyrighted by Clif Flynt, 2002
#
# It is licenced for public use with these terms:
#
#  This licence agreement must remain intact with the code.
# 
#  You may use this code freely for non-commercial purposes.
#
#  You may examine and modify the code to your heart's content.
#
#  You may not claim to have authored the code (aside from modifications
#  you may have made.)
#
#  You may not distribute the code without this license agreement
#
#  You may not sell this code or distribute it with a commercial product
#      without arrangements with Noumena Corporation.
#
#  Maintenance, extension, modification, etc can be performed by:
#
#   Noumena Corporation
#   9300 Fleming Rd.
#   Dexter, MI  48130
#
#   Contact: clif@noucorp.com
#
#####################################################################

package provide tcp 1.0
namespace eval tcp {

  set fields {
    source 	0	16
    dest 	16	16
    seq 	32	32
    ack_seq 	64	32
    hlen 	96	4
    res		100	6
    urg 	106	1
    ack 	107	1
    psh 	108	1
    rst 	109	1
    syn 	110	1
    fin 	111	1
    window 	112	16
    checksum   128	16
    urg_ptr    144	16
    option     160	0
    payload    160	{[expr 8 * [llength $val]]}
  }
  
  variable lookup

	set lookup(type.none) 		0
	set lookup(type.none.def)		{No defined values for TCP}
}

