set rev(udp_def.tcl) {$Header: /home/cvs/PacketMaker/udp_def.tcl,v 1.1.1.1 2002/12/02 01:37:04 clif Exp $}
#####################################################################
;# NAME:   udp_def.tcl
;# AUTHOR: Clif Flynt
;# DATE:   11/2002
;# DESC:   Definitions for manipulating UDP packets.
;#         
;#         
;#
;# PARAMETERS:  
;#
;#
#####################################################################
# This code is written and copyrighted by Clif Flynt, 2002
#
# It is licenced for public use with these terms:
#
#  This licence agreement must remain intact with the code.
# 
#  You may use this code freely for non-commercial purposes.
#
#  You may examine and modify the code to your heart's content.
#
#  You may not claim to have authored the code (aside from modifications
#  you may have made.)
#
#  You may not distribute the code without this license agreement
#
#  You may not sell this code or distribute it with a commercial product
#      without arrangements with Noumena Corporation.
#
#  Maintenance, extension, modification, etc can be performed by:
#
#   Noumena Corporation
#   9300 Fleming Rd.
#   Dexter, MI  48130
#
#   Contact: clif@noucorp.com
#
#####################################################################

package provide udp 1.0
namespace eval udp {

  set fields {
    source 	0	16
    dest 	16	16
    length	32	16
    checksum    48	16
    payload     64	{[expr 8 * [llength $val]]}
  }

	set lookup(type.none) 		0
	set lookup(type.none.def)		{No defined values for UDP}
}

